/* First Course in Java, EDP304758
   Homework 7
   Student 10JC, COCHRAN, John 
    Sample output:
    
Select an Animal:
  1. Cow
  2. Dog
  3. Sheep
Choose one (q to quit): 3


A Sheep makes the sound baa.
A Sheep eats grass for food.
A Sheep has 2 feet.
A sheep's wool hides their eyes.

*/
/**
 AnimalAbstract is an application that provides a menu of different animals and by selecting an animal it displays the sound that animal makes, the type of food it eats, the number of feet it has, and information about its eyes.  The program contains 3 class - one containing the main body of the program and for loop, one containing the menu functionality,  three information on each type of animal created (cow, dog, sheep), and the Animal class which is the basis for each type of animal.
**/


//abstract Class definition of Animal
abstract class Animal {
   //declare variables
   String animalname;
   String sound;
   String food;
   int feet;
   
   
   //eye method
   void eyes() {
      System.out.println("All animals have eyes.");
      }
   //abstract feet method to be implemented by subclasses
   abstract void feet();
      
}
//class definition of dog which is an extention of Animal class.
 class Dog extends Animal {
   /* Constructor for Dog.  Automatically initializes fields when an object is constructed */
   
   Dog ( String an, String s, String f, int fe) {
      animalname=an;
      sound=s;
      food=f;
      feet=fe;
   }
   
   
   //Speak method
   void speak() {
       System.out.println("A dog makes the sound " + sound + ".");
         }
   //Feed Method
   void feed(){
   
       System.out.println( "A dog eats " + food + " for food.");
      }
   // implementation of the inherited method which was abstract in the superclass
   void feet() {
      System.out.println( "A dog has " + feet + " feet.");
      }
}
//class difinition of Cow which is an extention of Animal class
 class Cow extends Animal {
   /* Constructor for Cow.  Automatically initializes fields when an object is constructed */
   
   Cow ( String an, String s, String f, int fe) {
      animalname=an;
      sound=s;
      food=f;
      feet=fe;
   }
   
   
   //Speak method
   void speak() {
       System.out.println("A cow makes the sound " + sound + ".");
         }
   //Feed Method
   void feed(){
   
       System.out.println( "A cow eats " + food + " for food.");
      }
   // implementation of the inherited method which was abstract in the superclass
   void feet() {
      System.out.println( "A cow has " + feet + " feet.");
      }
}
//class difinition of Sheep which is an extention of Animal class
 class Sheep extends Animal {
   /* Constructor for Sheep.  Automatically initializes fields when an object is constructed */
   
   Sheep ( String an, String s, String f, int fe) {
      animalname=an;
      sound=s;
      food=f;
      feet=fe;
   }
   
   
   //Speak method
   void speak() {
       System.out.println("A Sheep makes the sound " + sound + ".");
         }
   //Feed Method
   void feed(){
   
       System.out.println( "A Sheep eats " + food + " for food.");
      }
   // implementation of the inherited method which was abstract in the superclass
   void feet() {
      System.out.println( "A Sheep has " + feet + " feet.");
   }
   //Overriding eyes method of superclass
   void eyes() {
      System.out.println("A sheep's wool hides their eyes.");
      }
}

//Class definition of Menu
class Menu {
   //Menu choice method.  
   void menuchoice(int choice) {
      //switch statement tested against input based on display menu
      switch(choice) {
         
//Each case, if selected, passes values to the different types of animal Constructors when new creates the object. 
         
         case '1':
         Cow cow = new Cow("cow","moo","hay",4);
         //invokes the speak, feed, feet, and eyes methods on Cow
         //it will display the println statement from those methods
         //note that the eyes method is inherited from the Animal superclass
         cow.speak();
         cow.feed();
         cow.feet();
         cow.eyes();
         break;
         
         case '2':
         Dog dog = new Dog("dog","bark","kibbles",4);
         //invokes the speak, feed, feet, and eyes methods on Dog
         //it will display the println statement from those methods
         //note that the eyes method is inherited from the Animal superclass
         dog.speak();
         dog.feed();
         dog.feet();
         dog.eyes();
         break;
                     
         case '3':
         Sheep sheep = new Sheep("sheep","baa","grass",2);
         //invokes the speak, feed, feet, and eyes methods on Sheep
         //it will display the println statement from those methods
         //note that the eyes method from sheep is overriding the Animal superclass
         sheep.speak();
         sheep.feed();
         sheep.feet();
         sheep.eyes();
         break;
      }
      //outpus a blank line
      System.out.println();
      }
   //displaymenu method displays menu to standard output
   void displaymenu() {
      System.out.println("Select an Animal: ");
      System.out.println("  1. Cow");
      System.out.println("  2. Dog");
      System.out.println("  3. Sheep");
      System.out.print("Choose one (q to quit): ");
   }
   /*isvalid method checks that the input from the user is between the expected values of 1 thourgh 3 or q.*/
   boolean isvalid(int ch) {
      if(ch< '1' | ch > '3' & ch != 'q') return false;
      else return true;
   }
   
}

//AnimalEx class.  Entry point for program
class AnimalAbstract {
   public static void main (String [] args) 
   //throws IOException included because program accepts input form user
      throws java.io.IOException {
         char selection;
         //create new object menuobj from the Menu class
         Menu menuobj = new Menu();
      //infinite for loop displaying menu until 'q' is entered breaking the loop
         for( ; ; ){
            do {
               /*keep displaying the displaymenu method for the menu Object menuobj.*/
               menuobj.displaymenu();
               do {
                  /*read in input from user and assign to variable selection*/
                  selection=  (char) System.in.read();
               }  
            while (selection == '\n' | selection == '\r');
         }
         //invokes the isvalid method from menuobj object
         while ( !menuobj.isvalid(selection) );
         //if selection equals 'q' break for loop
         if(selection == 'q') break;
         System.out.println("\n");
         
         menuobj.menuchoice(selection);
         }
      }
   }

