//import myStuff.*;  // myStuff is a package
import yourStuff.YourStuffClass; // avoid fully-qualified name
import ourStuff.*;

public class RunStuff
{
   public static void main(String args[])
   {
      System.out.println("Inside RunStuff");
      
      // the fully-qualified name has the package name, followed by the dot operator, and the class name
      // a call to a constructor whose class happens to be in a package called myStuff
      myStuff.MyStuffClass msc = new myStuff.MyStuffClass();
      msc.callMe();
      
      YourStuffClass ysc = new YourStuffClass();
      ysc.callMe();
      
      OurStuffClass osc = new OurStuffClass();
      osc.callMe();
      DifferentClass dc = new DifferentClass();
      dc.greeting();
      
   }
}